/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-15 at 19:58:21 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * Options shared by read requests.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ReadOptions extends com.google.api.client.json.GenericJson {

  /**
   * The read consistency to use. One of default, strong, or eventual. Cannot be set when
   * transaction is set. Lookup and ancestor queries default to strong, global queries default to
   * eventual and cannot be set to strong. Optional. Default is default.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String readConsistency;

  /**
   * The transaction to use. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String transaction;

  /**
   * The read consistency to use. One of default, strong, or eventual. Cannot be set when
   * transaction is set. Lookup and ancestor queries default to strong, global queries default to
   * eventual and cannot be set to strong. Optional. Default is default.
   * @return value or {@code null} for none
   */
  public java.lang.String getReadConsistency() {
    return readConsistency;
  }

  /**
   * The read consistency to use. One of default, strong, or eventual. Cannot be set when
   * transaction is set. Lookup and ancestor queries default to strong, global queries default to
   * eventual and cannot be set to strong. Optional. Default is default.
   * @param readConsistency readConsistency or {@code null} for none
   */
  public ReadOptions setReadConsistency(java.lang.String readConsistency) {
    this.readConsistency = readConsistency;
    return this;
  }

  /**
   * The transaction to use. Optional.
   * @see #decodeTransaction()
   * @return value or {@code null} for none
   */
  public java.lang.String getTransaction() {
    return transaction;
  }

  /**
   * The transaction to use. Optional.
   * @see #getTransaction()
   * @return Base64 decoded value or {@code null} for none
   *
   * @since 1.14
   */
  public byte[] decodeTransaction() {
    return com.google.api.client.util.Base64.decodeBase64(transaction);
  }

  /**
   * The transaction to use. Optional.
   * @see #encodeTransaction()
   * @param transaction transaction or {@code null} for none
   */
  public ReadOptions setTransaction(java.lang.String transaction) {
    this.transaction = transaction;
    return this;
  }

  /**
   * The transaction to use. Optional.
   * @see #setTransaction()
   *
   * <p>
   * The value is encoded Base64 or {@code null} for none.
   * </p>
   *
   * @since 1.14
   */
  public ReadOptions encodeTransaction(byte[] transaction) {
    this.transaction = com.google.api.client.util.Base64.encodeBase64URLSafeString(transaction);
    return this;
  }

  @Override
  public ReadOptions set(String fieldName, Object value) {
    return (ReadOptions) super.set(fieldName, value);
  }

  @Override
  public ReadOptions clone() {
    return (ReadOptions) super.clone();
  }

}
