/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-15 at 19:58:21 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * The response for RunQuery.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class RunQueryResponse extends com.google.api.client.json.GenericJson {

  /**
   * A batch of query results (always present).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private QueryResultBatch batch;

  /**
   * The kind, fixed to "datastore#runQueryResponse".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * A batch of query results (always present).
   * @return value or {@code null} for none
   */
  public QueryResultBatch getBatch() {
    return batch;
  }

  /**
   * A batch of query results (always present).
   * @param batch batch or {@code null} for none
   */
  public RunQueryResponse setBatch(QueryResultBatch batch) {
    this.batch = batch;
    return this;
  }

  /**
   * The kind, fixed to "datastore#runQueryResponse".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind, fixed to "datastore#runQueryResponse".
   * @param kind kind or {@code null} for none
   */
  public RunQueryResponse setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  @Override
  public RunQueryResponse set(String fieldName, Object value) {
    return (RunQueryResponse) super.set(fieldName, value);
  }

  @Override
  public RunQueryResponse clone() {
    return (RunQueryResponse) super.clone();
  }

}
